const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2018-01-01";
pub const sdk_id: []const u8 = "FMS";
pub const arn_namespace: []const u8 = "fms";
pub const endpoint_prefix: []const u8 = "fms";
pub const sigv4_name: []const u8 = "fms";
pub const name: []const u8 = "AWSFMS_20180101";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2018-01-01",
    sdk_id: []const u8 = "FMS",
    arn_namespace: []const u8 = "fms",
    endpoint_prefix: []const u8 = "fms",
    sigv4_name: []const u8 = "fms",
    name: []const u8 = "AWSFMS_20180101",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const associate_admin_account: struct {
    action_name: []const u8 = "AssociateAdminAccount",
    Request: type = struct {
        admin_account: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_account = "AdminAccount",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(associate_admin_account) } {
            return .{ .service_metadata = service_metadata, .action = associate_admin_account };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const delete_apps_list: struct {
    action_name: []const u8 = "DeleteAppsList",
    Request: type = struct {
        list_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .list_id = "ListId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_apps_list) } {
            return .{ .service_metadata = service_metadata, .action = delete_apps_list };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const delete_notification_channel: struct {
    action_name: []const u8 = "DeleteNotificationChannel",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_notification_channel) } {
            return .{ .service_metadata = service_metadata, .action = delete_notification_channel };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const delete_policy: struct {
    action_name: []const u8 = "DeletePolicy",
    Request: type = struct {
        policy_id: []const u8,
        delete_all_policy_resources: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .delete_all_policy_resources = "DeleteAllPolicyResources",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_policy) } {
            return .{ .service_metadata = service_metadata, .action = delete_policy };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const delete_protocols_list: struct {
    action_name: []const u8 = "DeleteProtocolsList",
    Request: type = struct {
        list_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .list_id = "ListId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_protocols_list) } {
            return .{ .service_metadata = service_metadata, .action = delete_protocols_list };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const disassociate_admin_account: struct {
    action_name: []const u8 = "DisassociateAdminAccount",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(disassociate_admin_account) } {
            return .{ .service_metadata = service_metadata, .action = disassociate_admin_account };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_admin_account: struct {
    action_name: []const u8 = "GetAdminAccount",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_admin_account) } {
            return .{ .service_metadata = service_metadata, .action = get_admin_account };
        }
    },
    Response: type = struct {
        admin_account: ?[]const u8 = null,
        role_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_account = "AdminAccount",
                .role_status = "RoleStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_apps_list: struct {
    action_name: []const u8 = "GetAppsList",
    Request: type = struct {
        list_id: []const u8,
        default_list: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .list_id = "ListId",
                .default_list = "DefaultList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_apps_list) } {
            return .{ .service_metadata = service_metadata, .action = get_apps_list };
        }
    },
    Response: type = struct {
        apps_list: ?AppsListData = null,
        apps_list_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps_list = "AppsList",
                .apps_list_arn = "AppsListArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_compliance_detail: struct {
    action_name: []const u8 = "GetComplianceDetail",
    Request: type = struct {
        policy_id: []const u8,
        member_account: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .member_account = "MemberAccount",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_compliance_detail) } {
            return .{ .service_metadata = service_metadata, .action = get_compliance_detail };
        }
    },
    Response: type = struct {
        policy_compliance_detail: ?struct {
            policy_owner: ?[]const u8 = null,
            policy_id: ?[]const u8 = null,
            member_account: ?[]const u8 = null,
            violators: ?[]struct {
                resource_id: ?[]const u8 = null,
                violation_reason: ?[]const u8 = null,
                resource_type: ?[]const u8 = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .resource_id = "ResourceId",
                        .violation_reason = "ViolationReason",
                        .resource_type = "ResourceType",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            evaluation_limit_exceeded: ?bool = null,
            expired_at: ?i64 = null,
            issue_info_map: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_owner = "PolicyOwner",
                    .policy_id = "PolicyId",
                    .member_account = "MemberAccount",
                    .violators = "Violators",
                    .evaluation_limit_exceeded = "EvaluationLimitExceeded",
                    .expired_at = "ExpiredAt",
                    .issue_info_map = "IssueInfoMap",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "issue_info_map", field_name))
                    return try serializeMap(self.issue_info_map, self.fieldNameFor("issue_info_map"), options, out_stream);
                return false;
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_compliance_detail = "PolicyComplianceDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_notification_channel: struct {
    action_name: []const u8 = "GetNotificationChannel",
    Request: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_notification_channel) } {
            return .{ .service_metadata = service_metadata, .action = get_notification_channel };
        }
    },
    Response: type = struct {
        sns_topic_arn: ?[]const u8 = null,
        sns_role_name: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sns_topic_arn = "SnsTopicArn",
                .sns_role_name = "SnsRoleName",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_policy: struct {
    action_name: []const u8 = "GetPolicy",
    Request: type = struct {
        policy_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_policy) } {
            return .{ .service_metadata = service_metadata, .action = get_policy };
        }
    },
    Response: type = struct {
        policy: ?Policy = null,
        policy_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        InvalidType,
        ResourceNotFound,
    },
} = .{};
pub const get_protection_status: struct {
    action_name: []const u8 = "GetProtectionStatus",
    Request: type = struct {
        policy_id: []const u8,
        member_account_id: ?[]const u8 = null,
        start_time: ?i64 = null,
        end_time: ?i64 = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .member_account_id = "MemberAccountId",
                .start_time = "StartTime",
                .end_time = "EndTime",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_protection_status) } {
            return .{ .service_metadata = service_metadata, .action = get_protection_status };
        }
    },
    Response: type = struct {
        admin_account_id: ?[]const u8 = null,
        service_type: ?[]const u8 = null,
        data: ?[]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .admin_account_id = "AdminAccountId",
                .service_type = "ServiceType",
                .data = "Data",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const get_protocols_list: struct {
    action_name: []const u8 = "GetProtocolsList",
    Request: type = struct {
        list_id: []const u8,
        default_list: ?bool = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .list_id = "ListId",
                .default_list = "DefaultList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_protocols_list) } {
            return .{ .service_metadata = service_metadata, .action = get_protocols_list };
        }
    },
    Response: type = struct {
        protocols_list: ?ProtocolsListData = null,
        protocols_list_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols_list = "ProtocolsList",
                .protocols_list_arn = "ProtocolsListArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const get_violation_details: struct {
    action_name: []const u8 = "GetViolationDetails",
    Request: type = struct {
        policy_id: []const u8,
        member_account: []const u8,
        resource_id: []const u8,
        resource_type: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .member_account = "MemberAccount",
                .resource_id = "ResourceId",
                .resource_type = "ResourceType",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(get_violation_details) } {
            return .{ .service_metadata = service_metadata, .action = get_violation_details };
        }
    },
    Response: type = struct {
        violation_detail: ?struct {
            policy_id: []const u8,
            member_account: []const u8,
            resource_id: []const u8,
            resource_type: []const u8,
            resource_violations: []struct {
                aws_vpc_security_group_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    violation_target_description: ?[]const u8 = null,
                    partial_matches: ?[]struct {
                        reference: ?[]const u8 = null,
                        target_violation_reasons: ?[][]const u8 = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .reference = "Reference",
                                .target_violation_reasons = "TargetViolationReasons",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,
                    possible_security_group_remediation_actions: ?[]struct {
                        remediation_action_type: ?[]const u8 = null,
                        description: ?[]const u8 = null,
                        remediation_result: ?struct {
                            ipv4_range: ?[]const u8 = null,
                            ipv6_range: ?[]const u8 = null,
                            prefix_list_id: ?[]const u8 = null,
                            protocol: ?[]const u8 = null,
                            from_port: ?i64 = null,
                            to_port: ?i64 = null,

                            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                                const mappings = .{
                                    .ipv4_range = "IPV4Range",
                                    .ipv6_range = "IPV6Range",
                                    .prefix_list_id = "PrefixListId",
                                    .protocol = "Protocol",
                                    .from_port = "FromPort",
                                    .to_port = "ToPort",
                                };
                                return @field(mappings, field_name);
                            }
                        } = null,
                        is_default_action: ?bool = null,

                        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                            const mappings = .{
                                .remediation_action_type = "RemediationActionType",
                                .description = "Description",
                                .remediation_result = "RemediationResult",
                                .is_default_action = "IsDefaultAction",
                            };
                            return @field(mappings, field_name);
                        }
                    } = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .violation_target_description = "ViolationTargetDescription",
                            .partial_matches = "PartialMatches",
                            .possible_security_group_remediation_actions = "PossibleSecurityGroupRemediationActions",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                aws_ec2_network_interface_violation: ?AwsEc2NetworkInterfaceViolation = null,
                aws_ec2_instance_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    aws_ec2_network_interface_violations: ?[]AwsEc2NetworkInterfaceViolation = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .aws_ec2_network_interface_violations = "AwsEc2NetworkInterfaceViolations",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_missing_firewall_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    target_violation_reason: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .target_violation_reason = "TargetViolationReason",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_missing_subnet_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    target_violation_reason: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .target_violation_reason = "TargetViolationReason",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_missing_expected_rt_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    vpc: ?[]const u8 = null,
                    availability_zone: ?[]const u8 = null,
                    current_route_table: ?[]const u8 = null,
                    expected_route_table: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .vpc = "VPC",
                            .availability_zone = "AvailabilityZone",
                            .current_route_table = "CurrentRouteTable",
                            .expected_route_table = "ExpectedRouteTable",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                network_firewall_policy_modified_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    current_policy_description: ?NetworkFirewallPolicyDescription = null,
                    expected_policy_description: ?NetworkFirewallPolicyDescription = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .current_policy_description = "CurrentPolicyDescription",
                            .expected_policy_description = "ExpectedPolicyDescription",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                dns_rule_group_priority_conflict_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    violation_target_description: ?[]const u8 = null,
                    conflicting_priority: ?i64 = null,
                    conflicting_policy_id: ?[]const u8 = null,
                    unavailable_priorities: ?[]i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .violation_target_description = "ViolationTargetDescription",
                            .conflicting_priority = "ConflictingPriority",
                            .conflicting_policy_id = "ConflictingPolicyId",
                            .unavailable_priorities = "UnavailablePriorities",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                dns_duplicate_rule_group_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    violation_target_description: ?[]const u8 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .violation_target_description = "ViolationTargetDescription",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,
                dns_rule_group_limit_exceeded_violation: ?struct {
                    violation_target: ?[]const u8 = null,
                    violation_target_description: ?[]const u8 = null,
                    number_of_rule_groups_already_associated: ?i64 = null,

                    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                        const mappings = .{
                            .violation_target = "ViolationTarget",
                            .violation_target_description = "ViolationTargetDescription",
                            .number_of_rule_groups_already_associated = "NumberOfRuleGroupsAlreadyAssociated",
                        };
                        return @field(mappings, field_name);
                    }
                } = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .aws_vpc_security_group_violation = "AwsVPCSecurityGroupViolation",
                        .aws_ec2_network_interface_violation = "AwsEc2NetworkInterfaceViolation",
                        .aws_ec2_instance_violation = "AwsEc2InstanceViolation",
                        .network_firewall_missing_firewall_violation = "NetworkFirewallMissingFirewallViolation",
                        .network_firewall_missing_subnet_violation = "NetworkFirewallMissingSubnetViolation",
                        .network_firewall_missing_expected_rt_violation = "NetworkFirewallMissingExpectedRTViolation",
                        .network_firewall_policy_modified_violation = "NetworkFirewallPolicyModifiedViolation",
                        .dns_rule_group_priority_conflict_violation = "DnsRuleGroupPriorityConflictViolation",
                        .dns_duplicate_rule_group_violation = "DnsDuplicateRuleGroupViolation",
                        .dns_rule_group_limit_exceeded_violation = "DnsRuleGroupLimitExceededViolation",
                    };
                    return @field(mappings, field_name);
                }
            },
            resource_tags: ?[]Tag = null,
            resource_description: ?[]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_id = "PolicyId",
                    .member_account = "MemberAccount",
                    .resource_id = "ResourceId",
                    .resource_type = "ResourceType",
                    .resource_violations = "ResourceViolations",
                    .resource_tags = "ResourceTags",
                    .resource_description = "ResourceDescription",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .violation_detail = "ViolationDetail",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        ResourceNotFound,
    },
} = .{};
pub const list_apps_lists: struct {
    action_name: []const u8 = "ListAppsLists",
    Request: type = struct {
        default_lists: ?bool = null,
        next_token: ?[]const u8 = null,
        max_results: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .default_lists = "DefaultLists",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_apps_lists) } {
            return .{ .service_metadata = service_metadata, .action = list_apps_lists };
        }
    },
    Response: type = struct {
        apps_lists: ?[]struct {
            list_arn: ?[]const u8 = null,
            list_id: ?[]const u8 = null,
            list_name: ?[]const u8 = null,
            apps_list: ?[]App = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .list_arn = "ListArn",
                    .list_id = "ListId",
                    .list_name = "ListName",
                    .apps_list = "AppsList",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps_lists = "AppsLists",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const list_compliance_status: struct {
    action_name: []const u8 = "ListComplianceStatus",
    Request: type = struct {
        policy_id: []const u8,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_id = "PolicyId",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_compliance_status) } {
            return .{ .service_metadata = service_metadata, .action = list_compliance_status };
        }
    },
    Response: type = struct {
        policy_compliance_status_list: ?[]struct {
            policy_owner: ?[]const u8 = null,
            policy_id: ?[]const u8 = null,
            policy_name: ?[]const u8 = null,
            member_account: ?[]const u8 = null,
            evaluation_results: ?[]struct {
                compliance_status: ?[]const u8 = null,
                violator_count: ?i64 = null,
                evaluation_limit_exceeded: ?bool = null,

                pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                    const mappings = .{
                        .compliance_status = "ComplianceStatus",
                        .violator_count = "ViolatorCount",
                        .evaluation_limit_exceeded = "EvaluationLimitExceeded",
                    };
                    return @field(mappings, field_name);
                }
            } = null,
            last_updated: ?i64 = null,
            issue_info_map: ?[]struct {
                key: ?[]const u8 = null,
                value: ?[]const u8 = null,
            } = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_owner = "PolicyOwner",
                    .policy_id = "PolicyId",
                    .policy_name = "PolicyName",
                    .member_account = "MemberAccount",
                    .evaluation_results = "EvaluationResults",
                    .last_updated = "LastUpdated",
                    .issue_info_map = "IssueInfoMap",
                };
                return @field(mappings, field_name);
            }

            pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
                if (std.mem.eql(u8, "issue_info_map", field_name))
                    return try serializeMap(self.issue_info_map, self.fieldNameFor("issue_info_map"), options, out_stream);
                return false;
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_compliance_status_list = "PolicyComplianceStatusList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceNotFound,
    },
} = .{};
pub const list_member_accounts: struct {
    action_name: []const u8 = "ListMemberAccounts",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_member_accounts) } {
            return .{ .service_metadata = service_metadata, .action = list_member_accounts };
        }
    },
    Response: type = struct {
        member_accounts: ?[][]const u8 = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .member_accounts = "MemberAccounts",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        ResourceNotFound,
    },
} = .{};
pub const list_policies: struct {
    action_name: []const u8 = "ListPolicies",
    Request: type = struct {
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_policies) } {
            return .{ .service_metadata = service_metadata, .action = list_policies };
        }
    },
    Response: type = struct {
        policy_list: ?[]struct {
            policy_arn: ?[]const u8 = null,
            policy_id: ?[]const u8 = null,
            policy_name: ?[]const u8 = null,
            resource_type: ?[]const u8 = null,
            security_service_type: ?[]const u8 = null,
            remediation_enabled: ?bool = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .policy_arn = "PolicyArn",
                    .policy_id = "PolicyId",
                    .policy_name = "PolicyName",
                    .resource_type = "ResourceType",
                    .security_service_type = "SecurityServiceType",
                    .remediation_enabled = "RemediationEnabled",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy_list = "PolicyList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const list_protocols_lists: struct {
    action_name: []const u8 = "ListProtocolsLists",
    Request: type = struct {
        default_lists: ?bool = null,
        next_token: ?[]const u8 = null,
        max_results: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .default_lists = "DefaultLists",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_protocols_lists) } {
            return .{ .service_metadata = service_metadata, .action = list_protocols_lists };
        }
    },
    Response: type = struct {
        protocols_lists: ?[]struct {
            list_arn: ?[]const u8 = null,
            list_id: ?[]const u8 = null,
            list_name: ?[]const u8 = null,
            protocols_list: ?[][]const u8 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .list_arn = "ListArn",
                    .list_id = "ListId",
                    .list_name = "ListName",
                    .protocols_list = "ProtocolsList",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols_lists = "ProtocolsLists",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const put_apps_list: struct {
    action_name: []const u8 = "PutAppsList",
    Request: type = struct {
        apps_list: AppsListData,
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps_list = "AppsList",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_apps_list) } {
            return .{ .service_metadata = service_metadata, .action = put_apps_list };
        }
    },
    Response: type = struct {
        apps_list: ?AppsListData = null,
        apps_list_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .apps_list = "AppsList",
                .apps_list_arn = "AppsListArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const put_notification_channel: struct {
    action_name: []const u8 = "PutNotificationChannel",
    Request: type = struct {
        sns_topic_arn: []const u8,
        sns_role_name: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sns_topic_arn = "SnsTopicArn",
                .sns_role_name = "SnsRoleName",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_notification_channel) } {
            return .{ .service_metadata = service_metadata, .action = put_notification_channel };
        }
    },
    Response: type = struct {},
    ServiceError: type = error{
        InternalError,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};
pub const put_policy: struct {
    action_name: []const u8 = "PutPolicy",
    Request: type = struct {
        policy: Policy,
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_policy) } {
            return .{ .service_metadata = service_metadata, .action = put_policy };
        }
    },
    Response: type = struct {
        policy: ?Policy = null,
        policy_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .policy = "Policy",
                .policy_arn = "PolicyArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        InvalidType,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const put_protocols_list: struct {
    action_name: []const u8 = "PutProtocolsList",
    Request: type = struct {
        protocols_list: ProtocolsListData,
        tag_list: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols_list = "ProtocolsList",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(put_protocols_list) } {
            return .{ .service_metadata = service_metadata, .action = put_protocols_list };
        }
    },
    Response: type = struct {
        protocols_list: ?ProtocolsListData = null,
        protocols_list_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .protocols_list = "ProtocolsList",
                .protocols_list_arn = "ProtocolsListArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_list: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_list = "TagList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        LimitExceeded,
        ResourceNotFound,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalError,
        InvalidInput,
        InvalidOperation,
        ResourceNotFound,
    },
} = .{};

pub const Tag = struct {
    key: []const u8,
    value: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const ProtocolsListData = struct {
    list_id: ?[]const u8 = null,
    list_name: []const u8,
    list_update_token: ?[]const u8 = null,
    create_time: ?i64 = null,
    last_update_time: ?i64 = null,
    protocols_list: [][]const u8,
    previous_protocols_list: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .list_id = "ListId",
            .list_name = "ListName",
            .list_update_token = "ListUpdateToken",
            .create_time = "CreateTime",
            .last_update_time = "LastUpdateTime",
            .protocols_list = "ProtocolsList",
            .previous_protocols_list = "PreviousProtocolsList",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "previous_protocols_list", field_name))
            return try serializeMap(self.previous_protocols_list, self.fieldNameFor("previous_protocols_list"), options, out_stream);
        return false;
    }
};

pub const Policy = struct {
    policy_id: ?[]const u8 = null,
    policy_name: []const u8,
    policy_update_token: ?[]const u8 = null,
    security_service_policy_data: SecurityServicePolicyData,
    resource_type: []const u8,
    resource_type_list: ?[][]const u8 = null,
    resource_tags: ?[]ResourceTag = null,
    exclude_resource_tags: bool,
    remediation_enabled: bool,
    include_map: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,
    exclude_map: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[][]const u8 = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .policy_id = "PolicyId",
            .policy_name = "PolicyName",
            .policy_update_token = "PolicyUpdateToken",
            .security_service_policy_data = "SecurityServicePolicyData",
            .resource_type = "ResourceType",
            .resource_type_list = "ResourceTypeList",
            .resource_tags = "ResourceTags",
            .exclude_resource_tags = "ExcludeResourceTags",
            .remediation_enabled = "RemediationEnabled",
            .include_map = "IncludeMap",
            .exclude_map = "ExcludeMap",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "include_map", field_name))
            return try serializeMap(self.include_map, self.fieldNameFor("include_map"), options, out_stream);
        if (std.mem.eql(u8, "exclude_map", field_name))
            return try serializeMap(self.exclude_map, self.fieldNameFor("exclude_map"), options, out_stream);
        return false;
    }
};

pub const ResourceTag = struct {
    key: []const u8,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const SecurityServicePolicyData = struct {
    type: []const u8,
    managed_service_data: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .managed_service_data = "ManagedServiceData",
        };
        return @field(mappings, field_name);
    }
};

pub const AppsListData = struct {
    list_id: ?[]const u8 = null,
    list_name: []const u8,
    list_update_token: ?[]const u8 = null,
    create_time: ?i64 = null,
    last_update_time: ?i64 = null,
    apps_list: []App,
    previous_apps_list: ?[]struct {
        key: ?[]const u8 = null,
        value: ?[]App = null,
    } = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .list_id = "ListId",
            .list_name = "ListName",
            .list_update_token = "ListUpdateToken",
            .create_time = "CreateTime",
            .last_update_time = "LastUpdateTime",
            .apps_list = "AppsList",
            .previous_apps_list = "PreviousAppsList",
        };
        return @field(mappings, field_name);
    }

    pub fn jsonStringifyField(self: @This(), comptime field_name: []const u8, options: anytype, out_stream: anytype) !bool {
        if (std.mem.eql(u8, "previous_apps_list", field_name))
            return try serializeMap(self.previous_apps_list, self.fieldNameFor("previous_apps_list"), options, out_stream);
        return false;
    }
};

pub const App = struct {
    app_name: []const u8,
    protocol: []const u8,
    port: i64,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .app_name = "AppName",
            .protocol = "Protocol",
            .port = "Port",
        };
        return @field(mappings, field_name);
    }
};

pub const NetworkFirewallPolicyDescription = struct {
    stateless_rule_groups: ?[]StatelessRuleGroup = null,
    stateless_default_actions: ?[][]const u8 = null,
    stateless_fragment_default_actions: ?[][]const u8 = null,
    stateless_custom_actions: ?[][]const u8 = null,
    stateful_rule_groups: ?[]StatefulRuleGroup = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .stateless_rule_groups = "StatelessRuleGroups",
            .stateless_default_actions = "StatelessDefaultActions",
            .stateless_fragment_default_actions = "StatelessFragmentDefaultActions",
            .stateless_custom_actions = "StatelessCustomActions",
            .stateful_rule_groups = "StatefulRuleGroups",
        };
        return @field(mappings, field_name);
    }
};

pub const StatefulRuleGroup = struct {
    rule_group_name: ?[]const u8 = null,
    resource_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .rule_group_name = "RuleGroupName",
            .resource_id = "ResourceId",
        };
        return @field(mappings, field_name);
    }
};

pub const StatelessRuleGroup = struct {
    rule_group_name: ?[]const u8 = null,
    resource_id: ?[]const u8 = null,
    priority: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .rule_group_name = "RuleGroupName",
            .resource_id = "ResourceId",
            .priority = "Priority",
        };
        return @field(mappings, field_name);
    }
};

pub const AwsEc2NetworkInterfaceViolation = struct {
    violation_target: ?[]const u8 = null,
    violating_security_groups: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .violation_target = "ViolationTarget",
            .violating_security_groups = "ViolatingSecurityGroups",
        };
        return @field(mappings, field_name);
    }
};
